﻿@using Microsoft.EntityFrameworkCore
@using Microsoft.Extensions.Localization
@using OWebApplication.Operators
@using OWebApplication.Pages.Tasks
@using System.Threading
@using Sirkadirov.Overtest.SharedLibraries.ODataStoreLib.Models.TasksArchive

@inject AuthenticationStateProvider _authenticationStateProvider
@inject IDbContextFactory<OvertestDatabaseContext> _dbContextFactory
@inject IStringLocalizer<TasksArchive> _localizer
@inject NavigationManager _navigationManager
@inject UserAccessControlOperator _userAccessControlOperator
@inject UserManager<User> _userManager

@inject ISnackbar _snackbar

<style>
    .user-selectable
    {
        user-select: all !important;
        -webkit-user-select: all !important;
    }
</style>

<MudDialog>
    <TitleContent>
        <MudText Typo="Typo.h6">
            <MudIcon Icon="@Icons.Material.Filled.DeleteForever" Class="mr-3 mb-n1"/>
            @_localizer["Видалення завдання"]
        </MudText>
    </TitleContent>
    <DialogContent>
        <MudText Typo="Typo.body1" Class="my-3">
            @_localizer[
                "Ви впевнені, що хочере остаточно видалити це завдання? Видалення є цілком безповоротнім, " +
                "і жодним чином не може бути відмінено. Розм із завданням буде видалена інформація про " +
                "розв'язки до нього, буде перераховано рейтингові бали користувачів, воно зникне з результатів " +
                "змагань, тощо. Перед виконанням цієї операції радимо вам, за можливості, експортувати дані " +
                "завдання і розв'язки користувачів. За деталями зверніться до офіційної документації Overtest."]
        </MudText>
        @if (_programmingTask is not null)
        {
            <MudField Variant="Variant.Text" Margin="Margin.Dense" Class="user-selectable my-3"
                      Label="@_localizer["Ідентифікатор завдання"]"
            >@_programmingTask.Id</MudField>
            
            <MudField Variant="Variant.Text" Margin="Margin.Dense" Class="user-selectable my-3"
                      Label="@_localizer["Назва завдання"]"
            >@_programmingTask.Title</MudField>
            
            <MudField Variant="Variant.Text" Margin="Margin.Dense" Class="user-selectable my-3"
                      Label="@_localizer["Категорія завдання"]"
            >@(_programmingTask.Category ?? _localizer["Без категорії"])</MudField>
        }
    </DialogContent>
    <DialogActions>
        <MudButton Color="Color.Default" StartIcon="@Icons.Material.Outlined.Cancel"
                   OnClick="@(() => MudDialog.Close())">@_localizer["Відмінити"]</MudButton>
        <MudButton Color="Color.Error" StartIcon="@Icons.Material.Outlined.CheckCircle"
                   OnClick="OnDeleteButtonClickedAsync">@_localizer["Видалити остаточно"]</MudButton>
    </DialogActions>
</MudDialog>

@code {
    private SemaphoreSlim _semaphore;
    
    [CascadingParameter] public MudDialogInstance MudDialog { get; set; }
    [Parameter] public Guid ProgrammingTaskId { get; set; }

    private Guid _currentUserId;
    private bool _currentUserIsAdmin;

    private ProgrammingTask _programmingTask;

    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();
        
        MudDialog.SetOptions(new DialogOptions
        {
            CloseButton = true,
            DisableBackdropClick = true,
            FullScreen = false,
            FullWidth = true,
            MaxWidth = MaxWidth.Small,
            NoHeader = false,
            Position = DialogPosition.Center
        });

        _currentUserId = await GetCurrentUserIdAsync();
        _currentUserIsAdmin = await IsSuperUserAsync(_currentUserId);

        if (!_currentUserIsAdmin)
        {
            _snackbar.Add(_localizer["Ви не маєте необхідних прав доступу для виконання запитуваної операції!"],
                Severity.Error, options => options.CloseAfterNavigation = false);
            _navigationManager.NavigateTo("/tasks/archive");
            MudDialog.Close();
            return;
        }

        _semaphore = new SemaphoreSlim(1, 1);
        _programmingTask = null;

        async Task<Guid> GetCurrentUserIdAsync()
        {
            var authenticationState = await _authenticationStateProvider.GetAuthenticationStateAsync();
            return new Guid(_userManager.GetUserId(authenticationState.User));
        }

        async Task<bool> IsSuperUserAsync(Guid userId)
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();
            return await _userAccessControlOperator.HasUserTypeAsync(databaseContext,
                userId, UserType.SuperUser);
        }
    }

    protected override async Task OnParametersSetAsync()
    {
        await base.OnParametersSetAsync();

        if (!await IsProgrammingTaskExistsAsync())
        {
            _snackbar.Add(_localizer["Запитуваного вами завдання не знайдено у системі!"],
                Severity.Error, options => options.CloseAfterNavigation = false);
            _navigationManager.NavigateTo("/tasks/archive");
            MudDialog.Close();
            return;
        }

        await GetProgrammingTaskInfoAsync();
        StateHasChanged();

        async Task<bool> IsProgrammingTaskExistsAsync()
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();
            return await databaseContext.ProgrammingTasks.AnyAsync(t => t.Id == ProgrammingTaskId);
        }
    }

    private async Task GetProgrammingTaskInfoAsync()
    {
        await _semaphore.WaitAsync();
        try
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();
            _programmingTask = await databaseContext.ProgrammingTasks.AsNoTracking()
                .Where(t => t.Id == ProgrammingTaskId)
                .Select(s => new ProgrammingTask
                {
                    Id = s.Id,
                    Title = s.Title,
                    Category = s.Category,
                    RequiredCompilerId = s.RequiredCompilerId
                }).FirstAsync();
        }
        finally { _semaphore.Release(); }
    }

    private async Task OnDeleteButtonClickedAsync()
    {
        await _semaphore.WaitAsync();
        try
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();
            databaseContext.ProgrammingTasks.Remove(_programmingTask);
            await databaseContext.SaveChangesAsync();

            _snackbar.Add(_localizer["Завдання успішно видалено!"],
                Severity.Success, options => options.CloseAfterNavigation = false);
            _navigationManager.NavigateTo("/tasks/archive", true);

            MudDialog.Close();
        }
        catch (Exception)
        {
            _snackbar.Add(_localizer[
                "На жаль, нам не вдалося видалити завдання \"{0}\" з системи! Це може бути спричинено як внутрішньою " +
                "помилкою Overtest, так і задієнням цього завдання у активностях користувачів системи. Радимо вам " +
                "повторити спробу видалення цього завдання через деякий час.", _programmingTask.Title]);
            MudDialog.Close();
        }
        finally { _semaphore.Release(); }
    }
}